Attribute VB_Name = "modImageProcess"
'************************************************************************************
'Purpose: This function takes a variable and returns it's address.
'         Basically, it is the C++ '&' (adress) command
'************************************************************************************
Private Declare Function GetAddress Lib "converts.dll" ( _
            ByRef data As Byte) As Long



Public Function Get_Picture(Video_Control As VideoPortal, data() As Byte, ByRef Pic_Size As Long) As Boolean
                          
    Dim Ret_Value As Long   'Returns a 1 or 0, depending on functions success
    Dim Pic_Address As Long 'This is the address of the first element of the data
                            
    On Error GoTo GetPictureError
       
    '2 calls need to be made to the picture to memory function.  The first call
    'gets the amount of space needed to store the BMP data.  For the camera we used
    '(Logitech QuickCam Pro 3000), there are 3 sizes of images, each requiring a
    'different amount of space.
    Ret_Value = Video_Control.PictureToMemory(0, 24, 0, Pic_Size, "")
    
    'This statement is needed to setup the data array based on the Pic_Size
    ReDim data(Pic_Size)
    
    'This statement gets the address of the first element of the data array
    Pic_Address = GetAddress(data(0))
    
    'The 0 and the 24 are required by the Logitech driver.
    'Pic_Adress and Pic_Size are where to store and how much to store
    'the "" value allows for a text overlay.  I do not use it.
    Ret_Value = Video_Control.PictureToMemory(0, 24, Pic_Address, Pic_Size, "")
    
    GetPicture = True
    
Exit Function

GetPictureError:
    GetPicture = False
End Function



Public Function Display_Picture(Picture_Box As PictureBox, data() As Byte, ByRef Pic_Size As Long)

    Dim x As Integer        'The x-coordinate of the image
    Dim y As Integer        'The y-coordinate of the image
    
    Dim RGB_Offset As Long  'This is the number of bytes used for the header.
                            'Needed to get to the actual BMP data.
                            
    Dim i As Integer        'A runner to go through the picture array's bytes
                            
    RGB_Offset = 54         'There are 55 bytes needed for the header information.
                            'This is a constant for our images.  Less header is needed
                            'for a 24-bit image since the color information does not
                            'need to be saved.
                            
    x = 0                   'Start off at x = 0
    y = 120                 'BMP files are stored upside-down, so reading must begin
                            'from the bottom.

    
    'The following for loop goes through the entire data array by 3's (RGB) to display
    'the image.  It needs to get through the offset first, but then loops through the
    'rest.
    For i = 1 To (Pic_Size - 54) / 3
    
        'This is a very slow function that sets each pixel on the screen.  While it is
        'slow, it is fast enough for the testing program.  The data is stored GRB
        Picture_Box.PSet (x, y), RGB(data(RGB_Offset - 1), data(RGB_Offset - 2), data(RGB_Offset))
        
        'Add 3 to get the next pixel
        RGB_Offset = RGB_Offset + 3
        
        'If we are at the end of the line, start again, otherwise, go to the next pixel.
        If (i Mod (160)) = 0 Then
           x = 0
           y = y - 1
        Else
           x = x + 1
        End If
    Next i


End Function
