Attribute VB_Name = "modLogitech"
Public Function Setup_Registry(Video_Control As VideoPortal)
'************************************************************************************
'Purpose: This function sets up the nessecary registry settings.
'         They are required, but can be set to whatever you want.
'Inputs: Video_Portal Control
'
'Outputs: none
'************************************************************************************
    Video_Control.PrepareControl "SNC_COMPSCI", "HKEY_LOCAL_MACHINE\Software\SNC_COMPSCI\CAM_COMPSCI", 0
    Video_Control.PrepareControl "", "HKEY_CURRENT_USER\Software\Logitech\Sample1", 0
End Function

Public Function Connect_Camera(Video_Control As VideoPortal) As Boolean
'************************************************************************************
'Purpose: Connects the camera from the USB port to the computer.  It opens
'         up the port for use by the program.
'Inputs: Video_Portal Control
'
'Outputs: Boolean
'           0 = Failure
'           1 = Success
'************************************************************************************
    Connect_Camera = Video_Control.ConnectCamera2()
End Function

Public Function Setup_Preview(Video_Control As VideoPortal, Setting As Integer)
'************************************************************************************
'Purpose: Toggles the Preview option on and off.
'
'Inputs: Video_Portal Control
'        Setting:
'               0 = Off
'               1 = On
'
'Outputs: none
'
'************************************************************************************
    Video_Control.EnablePreview = Setting
End Function

Public Function Setup_Visible(Video_Control As VideoPortal, Setting As Integer)
'************************************************************************************
'Purpose: Toggles the Visible option on and off.
'
'Inputs: Video_Portal Control
'        Setting:
'               0 = Off
'               1 = On
'
'Outputs: none
'
'************************************************************************************
    Video_Control.Visible = Setting
End Function

Public Function Setup_Video(Video_Control As VideoPortal, Width As Integer, Height As Integer)
'************************************************************************************
'Purpose: Sets the video mode that is displayed by the camera
'
'Inputs:    Video_Portal Control
'           Width      Height
'            160        120
'            320        240
'            640        480
'
'Outputs: none
'
'************************************************************************************
    Video_Control.SetVideoFormat Width, Height, 24, 0
End Function

Public Function Setup_Orientation(Video_Control As VideoPortal, Setting As Integer) As Boolean
'************************************************************************************
'Purpose: Sets the video mode that is displayed by the camera
'
'Inputs: Video_Portal Control
'        Setting:
'           0 - Normal
'           1 - Mirrored
'           2 - Flipped
'           3 - Mirrored & Flipped
'
'Outputs: Boolean
'           0 = Failure
'           1 = Success
'************************************************************************************
    Setup_Orientation = Video_Control.SetCameraPropertyLong(0, Setting)
End Function

Public Function Setup_Brightness(Video_Control As VideoPortal, Setting As Integer) As Boolean
'************************************************************************************
'Purpose: Sets the Brightness property of the camera
'
'Inputs: Video_Portal Control
'        Setting:
'           0 - 255
'
'Outputs: Boolean
'           0 = Failure
'           1 = Success
'************************************************************************************
    Setup_Brightness = Video_Control.SetCameraPropertyLong(2, Setting)
End Function

Public Function Setup_Contrast(Video_Control As VideoPortal, Setting As Integer) As Boolean
'************************************************************************************
'Purpose: Sets the Contrast property of the camera
'
'Inputs: Video_Portal Control
'        Setting:
'           0 - 255
'
'Outputs: Boolean
'           0 = Failure
'           1 = Success
'************************************************************************************
    Setup_Contrast = Video_Control.SetCameraPropertyLong(3, Setting)
End Function

Public Function Setup_Saturation(Video_Control As VideoPortal, Setting As Integer) As Boolean
'************************************************************************************
'Purpose: Sets the Saturation property of the camera
'
'Inputs: Video_Portal Control
'        Setting:
'           0 - 255
'
'Outputs: Boolean
'           0 = Failure
'           1 = Success
'************************************************************************************
    Setup_Saturation = Video_Control.SetCameraPropertyLong(7, Setting)
End Function

Public Function Setup_Exposure(Video_Control As VideoPortal, Setting As Integer) As Boolean
'************************************************************************************
'Purpose: Sets the Exposure property of the camera
'
'Inputs: Video_Portal Control
'        Setting:
'           0 - 255
'
'Outputs: Boolean
'           0 = Failure
'           1 = Success
'************************************************************************************
    Setup_Exposure = Video_Control.SetCameraPropertyLong(8, Setting)
End Function

Public Function Setup_Hue(Video_Control As VideoPortal, Setting As Integer) As Boolean
'************************************************************************************
'Purpose: Sets the Hue property of the camera
'
'Inputs: Video_Portal Control
'        Setting:
'           0 - 255
'
'Outputs: Boolean
'           0 = Failure
'           1 = Success
'************************************************************************************
    Setup_Hue = Video_Control.SetCameraPropertyLong(14, Setting)
End Function

Public Function Setup_WhiteLevel(Video_Control As VideoPortal, Setting As Integer) As Boolean
'************************************************************************************
'Purpose: Sets the White Level property of the camera
'
'Inputs: Video_Portal Control
'        Setting:
'           0 - 255
'
'Outputs: Boolean
'           0 = Failure
'           1 = Success
'************************************************************************************
    Setup_WhiteLevel = Video_Control.SetCameraPropertyLong(21, Setting)
End Function

Public Function Setup_AnalogGain(Video_Control As VideoPortal, Setting As Integer) As Boolean
'************************************************************************************
'Purpose: Sets the Analog Gain property of the camera
'
'Inputs: Video_Portal Control
'        Setting:
'           0 - 255
'
'Outputs: Boolean
'           0 = Failure
'           1 = Success
'************************************************************************************
    Setup_AnalogGain = Video_Control.SetCameraPropertyLong(23, Setting)
End Function

Public Function Setup_AutoWhite(Video_Control As VideoPortal, Setting As Integer) As Boolean
'************************************************************************************
'Purpose: Sets the Auto White property of the camera
'
'Inputs: Video_Portal Control
'        Setting:
'           0 - 255
'
'Outputs: Boolean
'           0 = Failure
'           1 = Success
'************************************************************************************
    Setup_AutoWhite = Video_Control.SetCameraPropertyLong(22, Setting)
End Function

Public Function Setup_AutoGain(Video_Control As VideoPortal, Setting As Integer) As Boolean
'************************************************************************************
'Purpose: Sets the Auto Gain property of the camera
'
'Inputs: Video_Portal Control
'        Setting:
'           0 - 255
'
'Outputs: Boolean
'           0 = Failure
'           1 = Success
'************************************************************************************
    Setup_AutoGain = Video_Control.SetCameraPropertyLong(24, Setting)
End Function

Public Function Setup_StatusBar(Video_Control As VideoPortal, Setting As Integer)
'************************************************************************************
'Purpose: Sets the Brightness property of the camera
'
'Inputs: Video_Portal Control
'        Setting:
'           0 - Off
'           1 - On
'
'Outputs: none
'
'************************************************************************************
    Video_Control.EnableUIElements 3, 0, Setting
    Video_Control.EnableUIElements 4, 0, Setting
    Video_Control.EnableUIElements 5, 0, Setting
End Function
